// manifest constants
//
// it is okay for these to have forward references
// because the string substitution doesn't occur
// until the macro is used in the code far below
//

#ifndef CAPTURE_TO_DISK
#define CAPTURE_TO_DISK             FALSE
#endif
#ifndef CELLS_PER_BUFFER
#define CELLS_PER_BUFFER            1           // set to 0 when only ATM header was captured
#endif
#ifndef HOST_MUST_REASSEMBLE
#define HOST_MUST_REASSEMBLE        FALSE       // set to FALSE when all cells were captured
#endif

#define CELL_SIZE                   48L         // including only payload
#define BUFFER_SIZE                 (12 + CELLS_PER_BUFFER*CELL_SIZE) // including headers that SAR wants per buffer
#define SECTOR_SIZE                 512
#define MAX_BLOCK_SIZE              (1024*1024) // one megabyte

#define COMPL_RING_ENTRIES          (HW_RING_ENTRIES)
#define HW_RING_ENTRIES             (SECTOR_SIZE * (MAX_BLOCK_SIZE / (BUFFER_SIZE * SECTOR_SIZE)))

// how many cards we will use in host computer
//
#define MAX_ATM_NICS                2

// which is the first ATM card we will use (counting from zero)?
//
// this is meaningful when there are more cards in machine that wanted
//
#define ATM_NIC_OFFSET              0

// compile-time switches which depend on others
//
#if (CELLS_PER_BUFFER > 0) && !CAPTURE_TO_DISK
#define DO_FOREGROUND_STATS         TRUE
#else
#define DO_FOREGROUND_STATS         FALSE
#endif

