#include <io.h>                         // open() write() close()
#include <fcntl.h>                      // access for open()
#include <sys/stat.h>                   // create mode for open()
#include <errno.h>                      // errno
#include <stdio.h>                      // printf()
#include "..\dpmi32\phys.h"
#include "flat.h"



#define STEP_SIZE 1024*1024L



void main( void )
{
    Bit32 address;
    Bit32 *pointer;
    Bit32 value;
    int result;
    int handle;
    char filename[] = "d:\\flattest.dmp";

    flat_init();

    handle = open( filename, O_CREAT|O_TRUNC|O_BINARY|O_WRONLY, S_IWRITE|S_IREAD );
    if( handle < 0 )
    {
        printf( "error %d opening file '%s' for writing\n", errno, filename );
        return;
    }

    for( address=flat_start; address<PHYS_RAM_END; address+=STEP_SIZE )
    {
        pointer = (Bit32 *) physical_to_flat( address );
        printf( "writing to file from RAM at log/phy 0x%8.8lX/%8.8lX\n", pointer, address );

#if 0
        *pointer = address + 1234;
        value = *pointer;
        if( value != address + 1234 )
        {
            printf( "memory miscompare, got 0x%8.8lX, expected 0x%.8X\n", value, address+1234 );
            break;
        }
#endif

        result = write( handle, pointer, 3 );
        if( result < 0 )
        {
            printf( "file write error %d\n", errno );
            break;
        }
    }
    printf( "done\n" );

    flat_exit();
}
